W_kNumRowsToShow = 5;
W_kRaidButtonCountDefault = 40;
--This is where users can drop a item, spell or macro to create a custom list


--
-- Main Options Frame Stuff
--

function WO.Frame_Init() --called from Whammy.lua to init the checkboxes etc
	--W.ShowMessage("WhammyOptionsFrame Init");
	if ( W_Options.Mute == nil ) then W_Options.Mute = false; end
	if ( W_Options.ShowPetButtons == nil ) then W_Options.ShowPetButtons = true; end
	if ( W_Options.PetButtonLocation == nil ) then W_Options.PetButtonLocation = W_kPetButtonBottom; end
	if ( W_Options.FrameShape == nil ) then W_Options.FrameShape = W_kFrameShapeV; end
	if ( W_Options.PlayerButtonOnly == nil ) then W_Options.PlayerButtonOnly = false; end
	if ( W_Options.ShowSummary == nil ) then W_Options.ShowSummary = true; end
	if ( W_Options.ShowWhammy == nil ) then W_Options.ShowWhammy = true; end
	if ( W_Options.ButtonSize == nil ) then W_Options.ButtonSize = W_kButtonSizeStandard; end
	if ( W_Options.RaidButtonCount == nil ) then W_Options.RaidButtonCount = W_kRaidButtonCountDefault; end
	
	WhammyOptionsFrame_MuteAilmentSound_CheckButton:SetChecked( W_Options.Mute );
	WhammyOptionsFrame_PetButtonVisible_CheckButton:SetChecked( W_Options.ShowPetButtons );
	if ( W_Options.ShowPetButtons ) then --if the pet buttons are visible, enable the loc button, otherwise, disable it
		WhammyOptionsFrame_PetButtonLocation_CheckButton:Enable();
		WhammyOptionsFrame_PetButtonLocation_CheckButtonText:SetFontObject( "GameFontNormalSmall");
	else
		WhammyOptionsFrame_PetButtonLocation_CheckButton:Disable();
		WhammyOptionsFrame_PetButtonLocation_CheckButtonText:SetFontObject( "GameFontDisableSmall");
	end
	WhammyOptionsFrame_PetButtonLocation_CheckButton:SetChecked( W_Options.PetButtonLocation );
	WhammyOptionsFrame_HorizontalButtons_CheckButton:SetChecked( W_Options.FrameShape );
	WhammyOptionsFrame_ShowPlayerButtonOnly_CheckButton:SetChecked( W_Options.PlayerButtonOnly );
	WhammyOptionsFrame_Summary_CheckButton:SetChecked( W_Options.ShowSummary );
	WhammyOptionsFrame_ButtonSize_CheckButton:SetChecked( W_Options.ButtonSize );
	
	WO.Summary_CheckButton_Click( W_Options.ShowSummary );	-- show the summary frame or not
	
	--need to handle changing the raid button count
end

function WO.Frame_OnLoad()
	--W.ShowMessage("frame onload");

	WhammyOptionsFrame:SetWidth( 440 ); --adjust the size of the frame
	WhammyOptionsFrame:SetHeight( 334 );
	
	WhammyOptionsFrame_Heading:SetPoint("TOP", "WhammyOptionsFrame", 0, -10);
	WhammyOptionsFrame_Heading:SetText( W_kOptionsFrameHeading );
	
	WhammyOptionsFrame_Text:SetPoint("TOPLEFT", "WhammyOptionsFrame", 50, -45);
	WhammyOptionsFrame_Text:SetJustifyH("LEFT");
	WhammyOptionsFrame_Text:SetWidth( 200 );
	WhammyOptionsFrame_Text:SetText( W_kOptionsFrameText );
	
	WhammyOptionsFrame_RemoveButton:Disable();
	
	WhammyOptionsFrame_DefaultButton_Text:SetPoint("TOPLEFT", "WhammyOptionsFrame", 8, -276);
	WhammyOptionsFrame_DefaultButton_Text:SetJustifyH("LEFT");
	WhammyOptionsFrame_DefaultButton_Text:SetWidth( 200 )
	WhammyOptionsFrame_DefaultButton_Text:SetText( W_kOptionsFrameDefaultButtonDesc ); --the blurb telling what the button does
	WhammyOptionsFrame_DefaultButton:SetText( W_kOptionsFrameDefaultButtonText ); --the caption in the button
	
	WhammyOptionsFrame_Summary_CheckButtonText:SetText( W_kOptionsFrameSummaryCheckButtonText );
	
	WhammyOptionsFrame_PetButtonVisible_CheckButtonText:SetText( W_kPetButtonVisibleCheckButtonText );
	WhammyOptionsFrame_PetButtonLocation_CheckButtonText:SetText( W_kPetButtonLocationCheckButtonText );
	WhammyOptionsFrame_ButtonSize_CheckButtonText:SetText( W_kButtonSizeCheckButtonText );
	WhammyOptionsFrame_HorizontalButtons_CheckButtonText:SetText( W_kHorizontalButtonsCheckButtonText );
	WhammyOptionsFrame_ShowPlayerButtonOnly_CheckButtonText:SetText( W_kShowPlayerButtonOnlyText );
	
	WhammyOptionsFrame_MuteAilmentSound_CheckButtonText:SetText( W_kMuteAilmentSoundText );
	
	WhammyOptionsFrame_RaidButtonCount_Text:SetPoint("TOPLEFT", "WhammyOptionsFrame", 330, -200);
	WhammyOptionsFrame_RaidButtonCount_Text:SetJustifyH("LEFT");
	WhammyOptionsFrame_RaidButtonCount_Text:SetWidth( 100 )
	WhammyOptionsFrame_RaidButtonCount_Text:SetText( W_kRaidButtonCountText );
	
end

function WO.Frame_OnMouseUp() --if we click somewhere else in the frame, deselect any rows
	WO.Listbox_SetSelectedRow( 0 );--when we mouse up in just the frame, de-selected anything selected
end




--
-- DropSlot Stuff
--
function WO.Frame_DropSlot_Dropped()
	--see what the cursor is holding  "item"  "spell"  "macro"  "money"  "merchant"
	--W.ShowMessage("Slot Recieved Drag");
	local a,b,c = GetCursorInfo()
	
	if ( a == "item" ) then
		local itemID = b;
		local link = c;
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(itemID);
		W.AddCustomListRow( itemName, "item" );
		
	elseif (a == "spell") then
		local spellSlot = b;
		local spellOrPet = c;
		local spellName, spellRank, whichBook, spellTexture;
		
		if ( spellOrPet == "spell" ) then
			whichBook = BOOKTYPE_SPELL
		else
			whichBook = BOOKTYPE_PET
		end
		
		spellName, spellRank = GetSpellName( spellSlot, whichBook );
		local realSpellName = spellName.."("..spellRank..")"
		W.AddCustomListRow( realSpellName, "spell" );
		
	elseif (a == "macro") then
		local macroId = b;
		
		local macroName, macroTexture, macroBody, localVar = GetMacroInfo( macroId );
		W.AddCustomListRow( macroName, "macro" );
		
	elseif (a == "money") then
		local howMuch = b;
	elseif (a == "merchant") then
		local index = b;
	end

	ClearCursor();
	WO.Listbox_Update();
end

function WO.Frame_DropSlot_OnClick()
	--W.ShowMessage("dropslot onclick");
	local a,b,c = GetCursorInfo(); --if we clicked something, then clicked the dropslot, treat it like a drag and drop
	if ( a ) then
		WO.Frame_DropSlot_Dropped();
	end
end



--
-- Options checkboxes
--

function WO.Summary_CheckButton_Click( isChecked )
	local frame = WhammySummaryFrame
	if ( frame ) then
		if ( isChecked ) then
			frame:Show();
			W_Options.ShowSummary = true;
		else
			frame:Hide();
			W_Options.ShowSummary = false;
		end
	end
end


function WO.PetButtonVisible_CheckButton_Click( isChecked )
	local u, b;
	local unitID, hasAPet;
	
	if ( isChecked ) then --show pet buttons
		W_Options.ShowPetButtons = true;
		WhammyOptionsFrame_PetButtonLocation_CheckButton:Enable();
		WhammyOptionsFrame_PetButtonLocation_CheckButtonText:SetFontObject( "GameFontNormalSmall");
		for i = 1,40 do --walk through and show the pet buttons for any unit that has a pet
			u = getglobal("W_Unit_Button"..i);
			unitID = u:GetAttribute("unit");
			if ( unitID ~= nil ) then
				hasAPet = W.CharHasAPet( unitID );
				if ( hasAPet ) then
					b = getglobal("W_Pet_Button"..i);
					b:Show();
				end
			end
		end
	else --hide all pet buttons
		W_Options.ShowPetButtons = false;
		WhammyOptionsFrame_PetButtonLocation_CheckButton:Disable();
		WhammyOptionsFrame_PetButtonLocation_CheckButtonText:SetFontObject( "GameFontDisableSmall");
		for i = 1,40 do
			b = getglobal("W_Pet_Button"..i);
			b:Hide();
		end
	end
	
	W.Set_Whammy_Frame_Size();
end

function WO.PetButtonLocation_CheckButton_Click( isChecked ) --put the pet buttons to the right instead of below
	if ( isChecked ) then
		W_Options.PetButtonLocation = W_kPetButtonRight;
	else
		W_Options.PetButtonLocation = W_kPetButtonBottom;
	end
	
	W.Set_Whammy_Frame_Size();
end

function WO.ButtonSize_CheckButton_Click( isChecked )
	if ( isChecked ) then
		W_Options.ButtonSize = W_kButtonSizeSmall;
	else
		W_Options.ButtonSize = W_kButtonSizeStandard;
	end
	
	W.Set_Whammy_Frame_Size();
end

function WO.HorizontalButtons_CheckButton_Click( isChecked )
	if ( isChecked ) then
		W_Options.FrameShape = W_kFrameShapeH;
	else
		W_Options.FrameShape = W_kFrameShapeV;
	end
	
	W.Set_Whammy_Frame_Size();
end

function WO.ShowPlayerButtonOnly_CheckButton_Click( isChecked )
	if ( isChecked ) then
		W_Options.PlayerButtonOnly = true; --set whammy to only show this players button
	else
		W_Options.PlayerButtonOnly = false; --set whammy to show all players buttons
	end
	
	W.Set_Whammy_Frame_Size();
end

function WO.MuteAilmentSound_CheckButton_Click( isChecked )
	if ( isChecked ) then
		W_Options.Mute = true;
	else
		W_Options.Mute = false;
	end
end



--
-- Listbox Stuff Custom List
--
function WO.Listbox_OnLoad()
	--WhammyListboxScrollbar:Show()
end

function WO.Listbox_OnShow()
	--W.ShowMessage("Listbox OnShow");
	WO.Listbox_SetSelectedRow( 0 ); --when we unshow and show the window, deselect all rows
end

function WO.Listbox_OnClick( button )
	if ( button == "LeftButton" ) then
		--W.ShowMessage("left button");
		local buttonClicked = this:GetID(); --which button did they click 1-5
		local selectedRow = buttonClicked + FauxScrollFrame_GetOffset( WhammyOptionsFrame_Listbox_Scrollbar ); --which row in the table is this
		WO.Listbox_SetSelectedRow( selectedRow ); --keep track of the actual row in the table that was clicked
	else
		--W.ShowMessage("right button"); ignore right clicks in the list
	end
end

function WO.Listbox_Update()
	local row, rowNumInTable; -- 1 through 5 of our window to scroll
	local sb = WhammyOptionsFrame_Listbox_Scrollbar;  -- a reference to the scrollbar
	local rowOffset = FauxScrollFrame_GetOffset( sb ); -- how far has the scrollbar been scrolled? 1 click = 5 items at this time
	local numRowsInTable = W.GetCustomListRowCount() --how many rows in table minus the first row which is always Custom List
	local rowHeight = 16
	local lbData;	
	local lbButton;
	local selectedRow = WO.Listbox_GetSelectedRow(); --which row is selected in the listbox
	
	if ( selectedRow > 0 ) then --if something selected, enable the remove button
		WhammyOptionsFrame_RemoveButton:Enable();
	else
		WhammyOptionsFrame_RemoveButton:Disable();
	end

	for buttonNum=1,W_kNumRowsToShow do --walk through the # of buttons to display and either fill them in or hide them
		rowNumInTable = rowOffset + buttonNum; --the index to the actual row num in the table
		lbButton = getglobal("WhammyOptionsFrame_Listbox_Entry"..buttonNum); --the button we are drawing

		if ( rowNumInTable == selectedRow ) then --if the row we are accessing is the selected row, then highlight it
			lbButton:LockHighlight();
		else
			lbButton:UnlockHighlight();
		end
		
		if ( rowNumInTable > numRowsInTable ) then --hide the button if the button we are drawing is > the num of rows in the table
			lbButton:SetText("");
			lbButton:Hide();
		else --there is data in the row in the table, get it and show it
			local thingTable = W.GetCustomListRow( rowNumInTable )
			if ( thingTable ) then --if there is valid data, then show it in the listbox
				local thingName = thingTable[1]; -- the name of the item, spell or macro
				local thingType = thingTable[2]; -- will be item, spell or macro
				--lbData = W.GetCustomListRow( rowNumInTable ); --the data we need to draw in the button we are drawing
				lbButton:SetText( thingName ); --set the button text to the data
				lbButton:Show();
			end
		end
	end

	FauxScrollFrame_Update( sb, numRowsInTable, W_kNumRowsToShow, rowHeight );	-- ScrollFrame update
end

function WO.Listbox_GetSelectedRow()
	local selectedRow = WhammyOptionsFrame_Listbox.selectedRowInTable; --the selected row in the table (note that row 1 is always Custom List)
	
	return selectedRow
end

function WO.Listbox_SetSelectedRow( rowNum )
	WhammyOptionsFrame_Listbox.selectedRowInTable = rowNum;
	WO.Listbox_Update(); --refresh the listbox to show the change
end



---
--- functions dealing with the global custom list
---
function W.GetCustomListRow( rowNum )
	return W_gCustomList[ rowNum ]; --return the row data from the custom list table
end

function W.RemoveCustomListRow( rowNum )
	local removedItem = table.remove( W_gCustomList, rowNum ); --remove the row from the listbox data table
end

function W.AddCustomListRow( rowData, thingType ) --thingtype is item, spell or macro
	local thingTable = {rowData, thingType};
	table.insert( W_gCustomList, thingTable );
end

function W.GetCustomListRowCount()
	if ( W_gCustomList ) then
		local totalRows = table.getn( W_gCustomList ); --how many rows in the custom list table
		
		if ( totalRows ) then
			return totalRows;
		else
			return 0;
		end
	end
end



--
-- Remove Button Stuff
--
function WO.RemoveButton_OnClick()
	--W.ShowMessage("Remove button Click");
	
	local selectedRow = WO.Listbox_GetSelectedRow(); --the selected row in the table

	W.RemoveCustomListRow( selectedRow ); --remove the row from the listbox data table, row 1 is always Custom List
	
	WO.Listbox_SetSelectedRow( 0 ) --we removed the selected row, so set this to 0
	WO.Listbox_Update(); --refresh the listbox to show the change
end


--
-- Default Button Stuff
--
function WO.DefaultButton_OnClick() --clicking asks user if they are sure they want to reset back to defaults
	--W.ShowMessage("Button click");
	if ( StaticPopupDialogs["WHAMMY_DIALOG"] == nil ) then -- if we have not created this popup before, add it to the global popup table
		StaticPopupDialogs["WHAMMY_DIALOG"] = {
			text = "Are you sure you want to set popups to their defaults?",
			button1 = "Yes",
			button2 = "No",
			OnAccept = function()
				WO.DefaultButton_Set();
			end,
			timeout = 0,
			whileDead = 1,
			hideOnEscape = 1
		};
	end

	StaticPopup_Show("WHAMMY_DIALOG");
end

function WO.DefaultButton_Set()
	W.Set_Saved_Spells(); --set the saved spell table to the default spells for this type of char (priest, mage etc)
	
	for i = 1,W_kMaxDropDownButtons do --now walk through the buttons and set their text
		local dropDownName = "W_DropDown"..i --each drop down
		local ddFrame = getglobal( dropDownName ); -- and the drop down frame
		local spellName = W_gSavedSpells[dropDownName]; -- and the spells that we want to default the drop down to
		--W.ShowMessage( dropDownName.." = "..spellName );
		UIDropDownMenu_SetSelectedName( ddFrame, spellName); --set the selected item in the list
		UIDropDownMenu_SetText( spellName, ddFrame ); --also put the name of the spell in the text area
		
		if ( W_gDropDownCustomList[dropDownName] ) then --if this was previously set to a custom list, remove the entry from the table
			W_gDropDownCustomList[dropDownName] = nil;
		end
		if ( W_gSavedMacros[dropDownName] ) then --if this was previously set to a macro, remove the entry from the table
			W_gSavedMacros[dropDownName] = nil;
		end
	end
	
	W.Update_Unit_Buttons();
	
	-- set the health value drop down to default
	UIDropDownMenu_SetSelectedName( W_Health_DropDown, "Off" ); --set the dropdown selection
	W_gHealthLevel = "Off"
	
	UIDropDownMenu_SetSelectedName( W_Health2_DropDown, "Off" ); --set the dropdown2 selection
	W_gHealthLevel2 = "Off"
end


--
-- RaidButtonCount DropDown Menu handler
--
function WO.RaidButtonCount_DropDownHandler_OnShow()
	local dd = getglobal("W_RaidButtonCount_DropDown");

	UIDropDownMenu_Initialize( this, WO.RaidButtonCount_DropDownHandler_Initialize );
	UIDropDownMenu_SetText( W_Options.RaidButtonCount, dd);--init to the saved var
	UIDropDownMenu_SetWidth(40, dd );
end

function WO.RaidButtonCount_DropDownHandler_Initialize()
	local dd = getglobal("W_RaidButtonCount_DropDown");
	local selectedText = UIDropDownMenu_GetText( dd ); --get the option that is selected in the dropdown
	local index, menuItem;
	local t = {"1","5","10","25","40"}; --table for the number of buttons to display while in a raid
	local func = function() WO.RaidButtonCount_DropDownHandler_OnClick() end; --the function to be called when a dropdown item is selected
	
	for index, menuItem in pairs( t ) do --iterate over the key, values pairs from the table
		info = UIDropDownMenu_CreateInfo();
		info.text =  menuItem; --the text to show in the menu
		info.value = menuItem; --the value ( the index ) of the item
		info.func = func; --the function to call when the item is selected
		info.checked = (menuItem == selectedText) --if this is the item that is selected, then check it
		UIDropDownMenu_AddButton( info, 1 ); --1 is the menu level
	end
end

function WO.RaidButtonCount_DropDownHandler_OnClick()
	local dd = getglobal("W_RaidButtonCount_DropDown");
	local selectedText = this.value; --keep track of what we selected ( the text of it )
	
	UIDropDownMenu_SetText(selectedText, dd); --set the frame text
	local theNum = tonumber(selectedText) --convert the string to a number used for comparison and calculations later
	
	if ( W_Options.RaidButtonCount ~= theNum ) then --if we are changing the # of raid buttons, then make the change and if we are in a raid, change it
		W_Options.RaidButtonCount = theNum; --keep track of the new selection so it will be saved when we log
		--W.Set_Whammy_Frame_Size(); --for bug testing
		if ( W.IsRaid() ) then --if we are in a raid, change the # of buttons displayed
			W.Set_Whammy_Frame_Size();
		end
	end
end
